﻿Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition
Imports System.Collections.ObjectModel
Imports System.Data.OleDb
Imports System.Reflection
Public Class frmRangedTheme
   Public Sub New()


      ' This call is required by the designer.
      InitializeComponent()

      ListView1.Columns.Add("Colors", 100, HorizontalAlignment.Left)

      txt1.Text = "Select a start color and an end color, then click the apply button. Notice that some combinations will always generate an exception. For example, if you pick yellow for the start color and black for the end color a System.Overflow exception will be thrown."

   End Sub
   Private Sub frmValueTheme_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
      'mLoadFieldCombo()
   End Sub
   Private Sub mGetColors()
      Dim oGeoColor As GeoColor

      '***** Create some area symbols for the class breaks
      Dim oColors As Collection(Of GeoColor)
      Try
         oColors = GeoColor.GetColorsInQualityFamily(ColorToGeoColor(pctStartColor.BackColor), ColorToGeoColor(pctEndColor.BackColor), CInt(uneNumRanges.Value), ColorWheelDirection.Clockwise)
      Catch ex As Exception
         MessageBox.Show("Exception raised: " & ex.ToString)
         Return
      End Try

      Dim oItem As ListViewItem
      Dim i As Integer = 1
      ListView1.Items.Clear()
      ListView1.View = View.List
      For Each oGeoColor In oColors
         oItem = New ListViewItem("Color " & i.ToString)
         oItem.BackColor = GeoColorToColor(oGeoColor)
         'oItem.BackColor = Color.Blue
         ListView1.Items.Add(oItem)
         i += 1
      Next oGeoColor


   End Sub
   Public Shared Function GeoColorToColor(ByVal oGeoColor As GeoColor) As Color
      Try
         Return Color.FromArgb(oGeoColor.AlphaComponent, oGeoColor.RedComponent, oGeoColor.GreenComponent, oGeoColor.BlueComponent)
      Catch
         Return Nothing
      End Try
   End Function
   Public Shared Function ColorToGeoColor(ByVal oColor As Color) As GeoColor
      Try
         Return GeoColor.FromArgb(oColor.A, oColor.R, oColor.G, oColor.B)
      Catch
         Return Nothing
      End Try
   End Function
   Public Shared Function CreateSolidColorBitmap(
   ByVal iWidth As Integer,
   ByVal iHeight As Integer,
   ByVal oColor As Color) As Bitmap

      Dim oBitmap As Bitmap
      Dim oGraphics As Graphics
      Dim oBitmapSize As New SizeF(iWidth, iHeight)
      Dim rectFToFill As New RectangleF(New Point(0, 0), oBitmapSize)
      Dim oBrush As Brush
      '***** Create a new bitmap of the correct size
      oBitmap = New Bitmap(iWidth, iHeight)
      '***** Get a Gaphics object to do the drawing
      oGraphics = Graphics.FromImage(oBitmap)
      If oColor.A = 0 Then
         oBrush = New System.Drawing.Drawing2D.HatchBrush(Drawing2D.HatchStyle.BackwardDiagonal, Color.DarkSlateGray, Color.White)
      Else
         '***** Draw the color to the bitmap
         oBrush = New SolidBrush(oColor)
      End If

      oGraphics.FillRectangles(oBrush, New RectangleF() {rectFToFill})

      Return oBitmap
   End Function

   Private Sub pctStartColor_DoubleClick(sender As Object, e As System.EventArgs) Handles pctStartColor.DoubleClick, pctEndColor.DoubleClick
      Dim oDlg As New ColorDialog
      Dim eResult As DialogResult = oDlg.ShowDialog()

      If eResult = Windows.Forms.DialogResult.Cancel Then
         Return
      End If

      CType(sender, PictureBox).BackColor = oDlg.Color

   End Sub

   Private Sub btnApply_Click(sender As System.Object, e As System.EventArgs) Handles btnApply.Click
      mGetColors()
   End Sub
End Class